#include "freertos/FreeRTOS.h"
#include "esp_wifi.h"
#include "esp_system.h"
#include "esp_event.h"
#include "esp_event_loop.h"
#include "nvs_flash.h"
#include "driver/gpio.h"
#include "iot_a4988.h"


// Make app_main look like a C function to the linker.
extern "C" {
   void app_main(void);
}

#define STEPS_PER_REV (20*36)

void test_a_stepper(void) {

  CA4988Stepper stepper(CONFIG_STEP_GPIO, CONFIG_DIR_GPIO, STEPS_PER_REV,
      LEDC_HIGH_SPEED_MODE, LEDC_TIMER_0);

  stepper.setSpeedRpm(80, true);          // try 'instant' & see what happens
  stepper.step(100);
  vTaskDelay(1000/portTICK_RATE_MS);      // crash happens during this delay.
  stepper.step(-100);
  vTaskDelay(1000/portTICK_RATE_MS);

/*
  stepper.setSpeedRpm(rpm);
  stepper.step(steps);
  vTaskDelay(1000/portTICK_RATE_MS);
  stepper.step(-1*steps);
  vTaskDelay(1000/portTICK_RATE_MS);
*/

/*
  stepper2.setSpeedRpm(rpm);
  stepper2.step(steps);
  vTaskDelay(1000/portTICK_RATE_MS);
  stepper2.step(-1*steps);
  vTaskDelay(1000/portTICK_RATE_MS);

  stepper2.setSpeedRpm(rpm);
  stepper2.step(steps);
  vTaskDelay(1000/portTICK_RATE_MS);
  stepper2.step(-1*steps);
  vTaskDelay(1000/portTICK_RATE_MS);

  stepper.setSpeedRpm(60*3);
  stepper2.setSpeedRpm(60*3);
  stepper.run(1);
  stepper2.run(1);
  vTaskDelay(5000/portTICK_RATE_MS);
  stepper.run(-1);
  stepper2.run(-1);
  vTaskDelay(5000/portTICK_RATE_MS);
  stepper.stop();
  stepper2.stop();
*/


}

void app_main(void) {
  /*
    nvs_flash_init();
    tcpip_adapter_init();
    ESP_ERROR_CHECK( esp_event_loop_init(event_handler, NULL) );
    wifi_init_config_t cfg = WIFI_INIT_CONFIG_DEFAULT();
    ESP_ERROR_CHECK( esp_wifi_init(&cfg) );
    ESP_ERROR_CHECK( esp_wifi_set_storage(WIFI_STORAGE_RAM) );
    ESP_ERROR_CHECK( esp_wifi_set_mode(WIFI_MODE_STA) );
    wifi_config_t sta_config = {
        .sta = {
            .ssid = CONFIG_ESP_WIFI_SSID,
            .password = CONFIG_ESP_WIFI_PASSWORD,
            .bssid_set = false
        }
    };
    ESP_ERROR_CHECK( esp_wifi_set_config(WIFI_IF_STA, &sta_config) );
    ESP_ERROR_CHECK( esp_wifi_start() );
    ESP_ERROR_CHECK( esp_wifi_connect() );
*/
    // gpio_set_direction(GPIO_NUM_4, GPIO_MODE_OUTPUT);
    while (true) {
      test_a_stepper();
    }
}


